package cn.com.infosec.jce.provider;

import cn.com.infosec.jce.X509LDAPCertStoreParameters;
import cn.com.infosec.util.Selector;
import cn.com.infosec.x509.X509CRLStoreSelector;
import cn.com.infosec.x509.X509StoreParameters;
import cn.com.infosec.x509.X509StoreSpi;
import cn.com.infosec.x509.util.LDAPStoreHelper;
import java.util.Collection;
import java.util.Collections;
import java.util.HashSet;

public class X509StoreLDAPCRLs extends X509StoreSpi {
   private LDAPStoreHelper helper;

   public void engineInit(X509StoreParameters params) {
      if (params instanceof X509LDAPCertStoreParameters) {
         this.helper = new LDAPStoreHelper((X509LDAPCertStoreParameters)params);
      } else {
         throw new IllegalArgumentException("Initialization parameters must be an instance of " + X509LDAPCertStoreParameters.class.getName() + ".");
      }
   }

   public Collection engineGetMatches(Selector selector) {
      if (!(selector instanceof X509CRLStoreSelector)) {
         return Collections.EMPTY_SET;
      } else {
         X509CRLStoreSelector selector1;
         X509CRLStoreSelector var10000 = selector1 = (X509CRLStoreSelector)selector;
         HashSet var2;
         var2 = new HashSet.<init>();
         if (var10000.isDeltaCRLIndicatorEnabled()) {
            var2.addAll(this.helper.getDeltaCertificateRevocationLists(selector1));
         } else {
            var2.addAll(this.helper.getDeltaCertificateRevocationLists(selector1));
            var2.addAll(this.helper.getAttributeAuthorityRevocationLists(selector1));
            var2.addAll(this.helper.getAttributeCertificateRevocationLists(selector1));
            var2.addAll(this.helper.getAuthorityRevocationLists(selector1));
            var2.addAll(this.helper.getCertificateRevocationLists(selector1));
         }

         return var2;
      }
   }
}
